## GstTagDemux

GstTagDemux — Base class for demuxing tags that are in chunks directly at the beginning or at the end of a file

## Types and Values

struct | GstTagDemux
struct | GstTagDemuxClass
enum | GstTagDemuxResult

## Includes

    #include <gst/tag/tag.h>

## Description

Provides a base class for demuxing tags at the beginning or end of a stream and handles things like typefinding, querying, seeking, and different modes of operation (chain-based, pull_range-based, and providing downstream elements with random access if upstream supports that). The tag is stripped from the output, and all offsets are adjusted for the tag sizes, so that to the downstream element the stream will appear as if there was no tag at all. Also, once the tag has been parsed, GstTagDemux will try to determine the media type of the resulting stream and add a source pad with the appropriate caps in order to facilitate auto-plugging.

#### Deriving from GstTagDemux

Subclasses have to do four things:

- In their base init function, they must add a pad template for the sink pad to the element class, describing the media type they can parse in the caps of the pad template.

- In their class init function, they must override GST_TAG_DEMUX_CLASS(demux_klass)->identify_tag with their own identify function.

- In their class init function, they must override GST_TAG_DEMUX_CLASS(demux_klass)->parse_tag with their own parse function.

- In their class init function, they must also set GST_TAG_DEMUX_CLASS(demux_klass)->min_start_size and/or GST_TAG_DEMUX_CLASS(demux_klass)->min_end_size to the minimum size required for the identify function to decide whether the stream has a supported tag or not. A class parsing ID3v1 tags, for example, would set min_end_size to 128 bytes.

## Functions

## Types and Values

### struct GstTagDemux

    struct GstTagDemux {
      GstElement element;
    };

Opaque GstTagDemux structure.

#### Members

GstElement `element`; | parent element |

### struct GstTagDemuxClass

    struct GstTagDemuxClass {
      GstElementClass parent_class;

      /* minimum size required to identify a tag at the start and determine
       * its total size */
      guint                  min_start_size;

      /* minimum size required to identify a tag at the end and determine
       * its total size */
      guint                  min_end_size;

      /* vtable */

      /* identify tag and determine the size required to parse the tag */
      gboolean               (*identify_tag)  (GstTagDemux * demux,
                                               GstBuffer   * buffer,
                                               gboolean      start_tag,
                                               guint       * tag_size);

      /* parse the tag once it is identified and its size is known */
      GstTagDemuxResult      (*parse_tag)     (GstTagDemux * demux,
                                               GstBuffer   * buffer,
                                               gboolean      start_tag,
                                               guint       * tag_size,
                                               GstTagList ** tags);

      /* merge start and end tags (optional) */
      GstTagList *           (*merge_tags)    (GstTagDemux      * demux,
                                               const GstTagList * start_tags,
                                               const GstTagList * end_tags);
    };

The GstTagDemuxClass structure. See documentation at beginning of section for details about what subclasses need to override and do.

#### Members

guint `min_start_size`; | minimum size required to identify a tag at the start and determine its total size. Set to 0 if not interested in start tags. Subclasses should set this in their class_init function. |
guint `min_end_size`; | minimum size required to identify a tag at the end and determine its total size. Set to 0 if not interested in end tags. Subclasses should set this in their class_init function. |
`identify_tag` () | identify tag and determine the size required to parse the tag. Buffer may be larger than the specified minimum size. Subclassed MUST override this vfunc in their class_init function. |

`parse_tag` ()

parse the tag. Buffer will be exactly of the size determined by the identify_tag vfunc before. The parse_tag vfunc may change the size stored in *tag_size and return GST_TAG_DEMUX_RESULT_AGAIN to request a larger or smaller buffer. It is also permitted to adjust the tag_size to a smaller value and then return GST_TAG_DEMUX_RESULT_OK in one go. Subclassed MUST override the parse_tag vfunc in their class_init function.

`merge_tags` () | merge start and end tags. Subclasses may want to override this vfunc to allow prioritising of start or end tag according to user preference. Note that both start_tags and end_tags may be NULL. By default start tags are prefered over end tags. |

### enum GstTagDemuxResult

Result values from the parse_tag virtual function.

#### Members

GST_TAG_DEMUX_RESULT_BROKEN_TAG | cannot parse tag, just skip it |
GST_TAG_DEMUX_RESULT_AGAIN | call again with less or more data |
GST_TAG_DEMUX_RESULT_OK | parsed tag successfully |

## See Also

GstApeDemux, GstID3Demux